diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/ruleset.c freeciv-patched/server/ruleset.c
--- freeciv-cvs/server/ruleset.c	2003-06-30 12:33:44.000000000 +0100
+++ freeciv-patched/server/ruleset.c	2003-06-30 12:33:10.000000000 +0100
@@ -35,6 +35,7 @@
 #include "support.h"
 #include "tech.h"
 #include "unit.h"
+#include "unittype.h"
 
 #include "citytools.h"
 
@@ -63,8 +64,8 @@
 static Impr_Type_id lookup_impr_type(struct section_file *file, const char *prefix,
 				     const char *entry, bool required,
 				     const char *filename, const char *description);
-static int lookup_government(struct section_file *file, const char *entry,
-			     const char *filename);
+static int lookup_government(struct section_file *file, const char *prefix,
+			     const char *entry, const char *filename);
 static int lookup_city_cost(struct section_file *file, const char *prefix,
 			    const char *entry, const char *filename);
 static char *lookup_helptext(struct section_file *file, char *prefix);
@@ -96,6 +97,10 @@
 
 static void send_ruleset_techs(struct conn_list *dest);
 static void send_ruleset_units(struct conn_list *dest);
+static void send_ruleset_unit_modifier_types(struct conn_list *dest);
+static void send_ruleset_unit_modifiers(struct conn_list *dest);
+static void send_ruleset_gov_modifier_types(struct conn_list *dest);
+static void send_ruleset_gov_modifiers(struct conn_list *dest);
 static void send_ruleset_buildings(struct conn_list *dest);
 static void send_ruleset_terrain(struct conn_list *dest);
 static void send_ruleset_governments(struct conn_list *dest);
@@ -347,13 +352,13 @@
   Lookup entry in the file and return the corresponding government index;
   dies if can't find/match.  filename is for error message.
 **************************************************************************/
-static int lookup_government(struct section_file *file, const char *entry,
-			     const char *filename)
+static int lookup_government(struct section_file *file, const char *prefix,
+			     const char *entry, const char *filename)
 {
   char *sval;
   struct government *gov;
   
-  sval = secfile_lookup_str(file, "%s", entry);
+  sval = secfile_lookup_str(file, "%s.%s", prefix, entry);
   gov = find_government_by_name(sval);
   if (!gov) {
     freelog(LOG_FATAL, "for %s couldn't match government \"%s\" (%s)",
@@ -784,6 +789,23 @@
       e->cond_bldg = B_LAST;
     }
 
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.cond_govmod",
+				      secname, j);
+    if (*item != '\0') {
+      int govmod = find_gov_modifier_by_name(item);
+      if (govmod < 0) {
+	freelog(LOG_ERROR, "for %s effect[%d].cond_govmod couldn't match "
+			   "government modifier \"%s\" (%s)",
+		name, j, item, filename);
+	e->cond_govmod = game.num_gov_modifiers;
+	problem = TRUE;
+      } else {
+	e->cond_govmod = govmod;
+      }
+    } else {
+      e->cond_govmod = game.num_gov_modifiers;
+    }
+
     item = secfile_lookup_str_default(file, "", "%s.effect%d.cond_gov",
 				      secname, j);
     if (*item != '\0') {
@@ -900,17 +922,105 @@
 /**************************************************************************
 ...  
 **************************************************************************/
+static void read_modifier_types(struct section_file *file,
+    				struct modifier_type *modifier_types,
+				int *num_modifier_types)
+{
+  char **sec;
+  int num_mods, i;
+  const char *filename = secfile_filename(file);
+
+  /* Read modifier types from mod_type_xxx entries */
+  sec = secfile_get_secnames_prefix(file, "mod_type_", &num_mods);
+  if (num_mods > MAX_MODS) {
+    freelog(LOG_FATAL, "Too many modifier types! (%d, max %d; %s)",
+	    num_mods, MAX_MODS, filename);
+    exit(EXIT_FAILURE);
+  }
+  *num_modifier_types = num_mods;
+
+  /* Read in names first so that lookup works later on */
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier_type *um = &modifier_types[i];
+    sz_strlcpy(um->name, secfile_lookup_str(file, "%s.name", sec[i]));
+  }
+
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier_type *um = &modifier_types[i];
+
+    um->id = modifier_type_from_str(um->name, modifier_types, num_mods);
+    um->tech_requirement = lookup_tech(file, sec[i], "tech_req", 0,
+				       filename, um->name);
+    um->obsoleted_by = lookup_unit_type(file, sec[i], "obsolete_by", 0,
+					filename, um->name);
+    um->must_use = secfile_lookup_bool(file, "%s.must_use", sec[i]);
+  }
+  free(sec);
+}
+
+/**************************************************************************
+...  
+**************************************************************************/
+static struct modifier *read_modifiers(struct section_file *file,
+    				       int *num_modifiers,
+				       struct modifier_type *modifier_types,
+				       int num_modifier_types)
+{
+  char **sec;
+  int num_mods, i;
+  struct modifier *modifiers;
+  const char *filename = secfile_filename(file);
+
+  sec = secfile_get_secnames_prefix(file, "modifier_", &num_mods);
+  if (num_mods > U_LAST) {
+    freelog(LOG_FATAL, "Too many unit modifiers (%d, max %d) in %s",
+	    num_mods, U_LAST, filename);
+    exit(EXIT_FAILURE);
+  }
+  *num_modifiers = num_mods;
+  if (num_mods) {
+    modifiers = fc_calloc(num_mods, sizeof(struct modifier));
+  } else {
+    modifiers = NULL;
+  }
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier *um = &modifiers[i];
+    char *str;
+
+    sz_strlcpy(um->name, secfile_lookup_str(file, "%s.name", sec[i]));
+    um->tech_requirement = lookup_tech(file, sec[i], "tech_req",
+				       FALSE, filename, um->name);
+    um->action = mystrdup(secfile_lookup_str(file, "%s.action", sec[i]));
+    um->final_action = mystrdup(secfile_lookup_str(file, "%s.final_action",
+						   sec[i]));
+    str = secfile_lookup_str(file, "%s.type", sec[i]);
+    if ((um->type = modifier_type_from_str(str, modifier_types, num_modifier_types)) == -1) {
+      freelog(LOG_FATAL, "Bad unit modifier type %s for \"%s\" (%s)", str,
+	      um->name, filename);
+      exit(EXIT_FAILURE);
+    }
+    um->effect = load_effects(sec[i], um->name, file, FALSE, TRUE);
+  }
+  free(sec);
+  return modifiers;
+}
+
+/**************************************************************************
+...  
+**************************************************************************/
 static void load_ruleset_units(struct section_file *file)
 {
   char *datafile_options;
   struct unit_type *u;
-  int i, j, ival, nval;
-  char *sval, **slist, **sec;
+  int i, j, nval;
+  char **sec;
   const char *filename = secfile_filename(file);
 
   datafile_options =
     check_ruleset_capabilities(file, "+1.9", filename);
 
+  read_modifier_types(file, unit_modifier_types, &game.num_unit_modifier_types);
+
   sec = secfile_get_secnames_prefix(file, "unit_", &nval);
 
   /* Tech requirement is used to flag removed unit_types, which
@@ -923,69 +1033,16 @@
 				      FALSE, filename, u->name);
   } unit_type_iterate_end;
 
-  unit_type_iterate(i) {
-    u = &unit_types[i];
-    if (unit_type_exists(i)) {
-      u->obsoleted_by = lookup_unit_type(file, sec[i],
-					 "obsolete_by", FALSE, filename, u->name);
-    } else {
-      (void) section_file_lookup(file, "%s.obsolete_by", sec[i]); /* unused */
-      u->obsoleted_by = -1;
-    }
-  } unit_type_iterate_end;
-
   /* main stats: */
   unit_type_iterate(i) {
     u = &unit_types[i];
+    u->basetype = U_LAST;
+    utype_read_members(u, file, sec[i]);
 
     u->impr_requirement =
       find_improvement_by_name(secfile_lookup_str_default(file, "None", 
 					"%s.impr_req", sec[i]));
 
-    sval = secfile_lookup_str(file, "%s.move_type", sec[i]);
-    ival = unit_move_type_from_str(sval);
-    if (ival==0) {
-      freelog(LOG_FATAL, "for unit_type \"%s\": bad move_type %s (%s)",
-	   u->name, sval, filename);
-      exit(EXIT_FAILURE);
-    }
-    u->move_type = ival;
-    
-    sz_strlcpy(u->sound_move,
-	       secfile_lookup_str_default(file, "-", "%s.sound_move",
-					  sec[i]));
-    sz_strlcpy(u->sound_move_alt,
-	       secfile_lookup_str_default(file, "-", "%s.sound_move_alt",
-					  sec[i]));
-    sz_strlcpy(u->sound_fight,
-	       secfile_lookup_str_default(file, "-", "%s.sound_fight",
-					  sec[i]));
-    sz_strlcpy(u->sound_fight_alt,
-	       secfile_lookup_str_default(file, "-", "%s.sound_fight_alt",
-					  sec[i]));
-    
-    sz_strlcpy(u->graphic_str,
-	       secfile_lookup_str(file,"%s.graphic", sec[i]));
-    sz_strlcpy(u->graphic_alt,
-	       secfile_lookup_str(file,"%s.graphic_alt", sec[i]));
-    
-    u->build_cost =
-      secfile_lookup_int(file,"%s.build_cost", sec[i]);
-    u->pop_cost =
-      secfile_lookup_int(file,"%s.pop_cost", sec[i]);
-    u->attack_strength =
-      secfile_lookup_int(file,"%s.attack", sec[i]);
-    u->defense_strength =
-      secfile_lookup_int(file,"%s.defense", sec[i]);
-    u->move_rate =
-      SINGLE_MOVE*secfile_lookup_int(file,"%s.move_rate", sec[i]);
-    
-    u->vision_range =
-      secfile_lookup_int(file,"%s.vision_range", sec[i]);
-    u->transport_capacity =
-      secfile_lookup_int(file,"%s.transport_cap", sec[i]);
-    u->hp = secfile_lookup_int(file,"%s.hitpoints", sec[i]);
-    u->firepower = secfile_lookup_int(file,"%s.firepower", sec[i]);
     if (u->firepower <= 0) {
       freelog(LOG_FATAL, "for unit_type \"%s\": firepower is %d but "
 	      "must be at least 1.\nSet the unit's attack strength to 0 "
@@ -993,78 +1050,96 @@
 	      u->name, u->firepower, filename);
       exit(EXIT_FAILURE);
     }
-    u->fuel = secfile_lookup_int(file,"%s.fuel", sec[i]);
-
-    u->happy_cost  = secfile_lookup_int(file, "%s.uk_happy", sec[i]);
-    u->shield_cost = secfile_lookup_int(file, "%s.uk_shield", sec[i]);
-    u->food_cost   = secfile_lookup_int(file, "%s.uk_food", sec[i]);
-    u->gold_cost   = secfile_lookup_int(file, "%s.uk_gold", sec[i]);
-
     u->effect = load_effects(sec[i], u->name, file, TRUE, FALSE);
 
     u->helptext = lookup_helptext(file, sec[i]);
   } unit_type_iterate_end;
   
-  /* flags */
   unit_type_iterate(i) {
     u = &unit_types[i];
-    BV_CLR_ALL(u->flags);
-    assert(!unit_type_flag(i, F_LAST-1));
+    if (unit_type_flag(i, F_PARATROOPERS)) {
+      u->paratroopers_range = secfile_lookup_int(file,
+	  		"%s.paratroopers_range", sec[i]);
+      u->paratroopers_mr_req = SINGLE_MOVE * secfile_lookup_int(file,
+	  		"%s.paratroopers_mr_req", sec[i]);
+      u->paratroopers_mr_sub = SINGLE_MOVE * secfile_lookup_int(file,
+	  		"%s.paratroopers_mr_sub", sec[i]);
+    } else {
+      u->paratroopers_range = 0;
+      u->paratroopers_mr_req = 0;
+      u->paratroopers_mr_sub = 0;
+    }
+  } unit_type_iterate_end;
+  free(sec);
 
-    slist = secfile_lookup_str_vec(file, &nval, "%s.flags", sec[i]);
-    for(j=0; j<nval; j++) {
-      sval = slist[j];
-      if(strcmp(sval,"")==0) {
-	continue;
-      }
-	ival = unit_flag_from_str(sval);
-      if (ival==F_MAX) {
-	freelog(LOG_ERROR, "for unit_type \"%s\": bad flag name \"%s\" (%s)",
-	     u->name, sval, filename);
-      }
-      BV_SET(u->flags, ival);
-      assert(unit_type_flag(i, ival));
-
-      if(ival == F_PARATROOPERS) {
-        u->paratroopers_range = secfile_lookup_int(file,
-            "%s.paratroopers_range", sec[i]);
-        u->paratroopers_mr_req = 3*secfile_lookup_int(file,
-            "%s.paratroopers_mr_req", sec[i]);
-        u->paratroopers_mr_sub = 3*secfile_lookup_int(file,
-            "%s.paratroopers_mr_sub", sec[i]);
+  lookup_tech_list(file, "u_specials", "partisan_req",
+		   game.rtech.partisan_req, filename);
+
+  unit_modifiers = read_modifiers(file, &game.num_unit_modifiers,
+				  unit_modifier_types,
+				  game.num_unit_modifier_types);
+
+  sec = secfile_get_secnames_prefix(file, "compound_unit_", &nval);
+  for (i = 0; i < nval; ++i) {
+    int modifiers[MAX_MODS];
+    char *name, *sval;
+    Unit_Type_id basetype;
+    struct unit_type *utype;
+
+    name = secfile_lookup_str(file, "%s.name", sec[i]);
+    basetype = lookup_unit_type(file, sec[i], "base", TRUE,
+				filename, name);
+    freelog(LOG_DEBUG, "Forming compound unit %s", name);
+
+    for (j = 0; j < game.num_unit_modifier_types; ++j) {
+      sval = secfile_lookup_str(file, "%s.modifiers,%d", sec[i], j);
+      if (!unit_modifier_types[j].must_use && sval[0] == '\0') {
+	modifiers[j] = U_LAST;
       } else {
-        u->paratroopers_range = 0;
-        u->paratroopers_mr_req = 0;
-        u->paratroopers_mr_sub = 0;
+	int ival = find_unit_modifier_by_name(sval);
+
+	if (ival == U_LAST) {
+	   freelog(LOG_FATAL,
+		   "for %s, couldn't match unit modifier \"%s\" (%s)",
+		   sec[i], sval, filename);
+	   exit(EXIT_FAILURE);
+	} else if (unit_modifiers[ival].type != unit_modifier_types[j].id) {
+	  freelog(LOG_FATAL, "for %s, unit modifier \"%s\" is not of "
+		  "required compound type %s (%s)",
+		  sec[i], sval, unit_modifier_types[j].name,
+		  filename);
+	  exit(EXIT_FAILURE);
+	} else {
+	   modifiers[j] = ival;
+	}
       }
     }
-    free(slist);
-  } unit_type_iterate_end;
-    
-  /* roles */
+    utype = &unit_types[form_compound_unit(name, basetype, modifiers)];
+    /* Allow override of flags and roles if specified */
+    if (secfile_lookup_str_default(file, NULL, "%s.roles", sec[i])) {
+      utype_read_member(utype, "roles", file, sec[i]);
+    }
+    if (secfile_lookup_str_default(file, NULL, "%s.flags", sec[i])) {
+      utype_read_member(utype, "flags", file, sec[i]);
+    }
+  }
+  free(sec);
+
+  sec = secfile_get_secnames_prefix(file, "unit_", &nval);
   unit_type_iterate(i) {
     u = &unit_types[i];
-    BV_CLR_ALL(u->roles);
-    
-    slist = secfile_lookup_str_vec(file, &nval, "%s.roles", sec[i] );
-    for(j=0; j<nval; j++) {
-      sval = slist[j];
-      if(strcmp(sval,"")==0) {
-	continue;
-      }
-      ival = unit_role_from_str(sval);
-      if (ival==L_LAST) {
-	freelog(LOG_ERROR, "for unit_type \"%s\": bad role name \"%s\" (%s)",
-	     u->name, sval, filename);
+    if (u->basetype == U_LAST) {
+      if (unit_type_exists(i)) {
+	u->obsoleted_by = lookup_unit_type(file, sec[i],
+					   "obsolete_by", FALSE, filename,
+					   u->name);
+      } else {
+	(void) section_file_lookup(file, "%s.obsolete_by", sec[i]); /* unused */
+	u->obsoleted_by = -1;
       }
-      BV_SET(u->roles, ival - L_FIRST);
-      assert(unit_has_role(i, ival));
     }
-    free(slist);
   } unit_type_iterate_end;
-
-  lookup_tech_list(file, "u_specials", "partisan_req",
-		   game.rtech.partisan_req, filename);
+  free(sec);
 
   /* Some more consistency checking: */
   unit_type_iterate(i) {
@@ -1170,7 +1245,6 @@
 
   update_simple_ai_types();
 
-  free(sec);
   section_file_check_unused(file, filename);
   section_file_free(file);
 }
@@ -1636,33 +1710,13 @@
 
   sec = secfile_get_secnames_prefix(file, "government_", &nval);
 
-  game.default_government
-    = lookup_government(file, "governments.default", filename);
-  
-  game.government_when_anarchy
-    = lookup_government(file, "governments.when_anarchy", filename);
-  
-  game.ai_goal_government
-    = lookup_government(file, "governments.ai_goal", filename);
-
-  freelog(LOG_DEBUG, "govs: def %d, anarchy %d, ai_goal %d",
-	  game.default_government, game.government_when_anarchy,
-	  game.ai_goal_government);
-  
-  /* Because player_init is called before rulesets are loaded we set
-   * all players governments here, if they have not been previously
-   * set (eg by loading game).
-   */
-  for(i=0; i<MAX_NUM_PLAYERS+MAX_NUM_BARBARIANS; i++) {
-    if (game.players[i].government == G_MAGIC) {
-      game.players[i].government = game.default_government;
-    }
-  }
+  read_modifier_types(file, gov_modifier_types, &game.num_gov_modifier_types);
 
   /* easy ones: */
   for(i=0; i<game.government_count; i++) {
     g = &governments[i];
     
+    g->basetype = G_MAGIC;
     g->required_tech
       = lookup_tech(file, sec[i], "tech_req", FALSE, filename, g->name);
     
@@ -1726,32 +1780,32 @@
       = secfile_lookup_int_default(file, 36, "%s.waste_max_distance_cap", sec[i]); 
 
     g->trade_bonus
-      = secfile_lookup_int(file, "%s.production_trade_bonus", sec[i]);
+      = secfile_lookup_int(file, "%s.trade_bonus", sec[i]);
     g->shield_bonus
-      = secfile_lookup_int(file, "%s.production_shield_bonus", sec[i]);
+      = secfile_lookup_int(file, "%s.shield_bonus", sec[i]);
     g->food_bonus
-      = secfile_lookup_int(file, "%s.production_food_bonus", sec[i]);
+      = secfile_lookup_int(file, "%s.food_bonus", sec[i]);
 
     g->celeb_trade_bonus
-      = secfile_lookup_int(file, "%s.production_trade_bonus,1", sec[i]);
+      = secfile_lookup_int(file, "%s.celeb_trade_bonus", sec[i]);
     g->celeb_shield_bonus
-      = secfile_lookup_int(file, "%s.production_shield_bonus,1", sec[i]);
+      = secfile_lookup_int(file, "%s.celeb_shield_bonus", sec[i]);
     g->celeb_food_bonus
-      = secfile_lookup_int(file, "%s.production_food_bonus,1", sec[i]);
+      = secfile_lookup_int(file, "%s.celeb_food_bonus", sec[i]);
 
     g->trade_before_penalty
-      = secfile_lookup_int(file, "%s.production_trade_penalty", sec[i]);
+      = secfile_lookup_int(file, "%s.trade_penalty", sec[i]);
     g->shields_before_penalty
-      = secfile_lookup_int(file, "%s.production_shield_penalty", sec[i]);
+      = secfile_lookup_int(file, "%s.shield_penalty", sec[i]);
     g->food_before_penalty
-      = secfile_lookup_int(file, "%s.production_food_penalty", sec[i]);
+      = secfile_lookup_int(file, "%s.food_penalty", sec[i]);
 
     g->celeb_trade_before_penalty
-      = secfile_lookup_int(file, "%s.production_trade_penalty,1", sec[i]);
+      = secfile_lookup_int(file, "%s.celeb_trade_penalty", sec[i]);
     g->celeb_shields_before_penalty
-      = secfile_lookup_int(file, "%s.production_shield_penalty,1", sec[i]);
+      = secfile_lookup_int(file, "%s.celeb_shield_penalty", sec[i]);
     g->celeb_food_before_penalty
-      = secfile_lookup_int(file, "%s.production_food_penalty,1", sec[i]);
+      = secfile_lookup_int(file, "%s.celeb_food_penalty", sec[i]);
 
     g->effect = load_effects(sec[i], g->name, file, FALSE, TRUE);
     
@@ -1836,6 +1890,72 @@
     }
     freelog(LOG_DEBUG, "%s subgoal %d", g->name, g->subgoal);
   }
+  free(sec);
+
+  gov_modifiers = read_modifiers(file, &game.num_gov_modifiers,
+      				 gov_modifier_types,
+				 game.num_gov_modifier_types);
+
+  sec = secfile_get_secnames_prefix(file, "compound_government_", &nval);
+  for (i = 0; i < nval; ++i) {
+    int modifiers[MAX_MODS];
+    char *name, *sval;
+    int basetype;
+
+    name = secfile_lookup_str(file, "%s.name", sec[i]);
+    basetype = lookup_government(file, sec[i], "base", filename);
+    freelog(LOG_DEBUG, "Forming compound gov %s", name);
+
+    for (j = 0; j < game.num_gov_modifier_types; ++j) {
+      sval = secfile_lookup_str(file, "%s.modifiers,%d", sec[i], j);
+      if (!gov_modifier_types[j].must_use && sval[0] == '\0') {
+	modifiers[j] = -1;
+      } else {
+	int ival = find_gov_modifier_by_name(sval);
+
+        if (ival < 0) {
+          freelog(LOG_FATAL,
+		  "for %s, couldn't match gov modifier \"%s\" (%s)",
+		  sec[i], sval, filename);
+	  exit(EXIT_FAILURE);
+	} else if (gov_modifiers[ival].type != gov_modifier_types[j].id) {
+	  freelog(LOG_FATAL, "for %s, gov modifier \"%s\" is not of "
+		  "required compound type %s (%s)",
+		  sec[i], sval, gov_modifier_types[j].name,
+		  filename);
+	  exit(EXIT_FAILURE);
+	} else {
+	  modifiers[j] = ival;
+	}
+      }
+    }
+    form_compound_gov(NULL, name, basetype, modifiers);
+  }
+  free(sec);
+
+  game.default_government
+    = lookup_government(file, "governments", "default", filename);
+  
+  game.government_when_anarchy
+    = lookup_government(file, "governments", "when_anarchy", filename);
+  
+  game.ai_goal_government
+    = lookup_government(file, "governments", "ai_goal", filename);
+
+  freelog(LOG_DEBUG, "govs: def %d, anarchy %d, ai_goal %d",
+	  game.default_government, game.government_when_anarchy,
+	  game.ai_goal_government);
+  
+  /* Because player_init is called before rulesets are loaded we set
+   * all players governments here, if they have not been previously
+   * set (eg by loading game).
+   */
+  for(i=0; i<MAX_NUM_PLAYERS+MAX_NUM_BARBARIANS; i++) {
+    if (game.players[i].government == G_MAGIC) {
+      game.players[i].government = game.default_government;
+    }
+  }
+
     
   /* ai tech_hints: */
   j = -1;
@@ -1872,7 +1992,6 @@
     ai_gov_tech_hints[j].tech = A_LAST;
   }
 
-  free(sec);
   section_file_check_unused(file, filename);
   section_file_free(file);
 }
@@ -1910,6 +2029,11 @@
   packet.num_impr_types = game.num_impr_types;
   packet.num_tech_types = game.num_tech_types;
 
+  packet.num_unit_modifier_types = game.num_unit_modifier_types;
+  packet.num_unit_modifiers = game.num_unit_modifiers;
+  packet.num_gov_modifier_types = game.num_gov_modifier_types;
+  packet.num_gov_modifiers = game.num_gov_modifiers;
+
   packet.nation_count = game.nation_count;
   packet.playable_nation_count = game.playable_nation_count;
   packet.style_count = game.styles_count;
@@ -2579,53 +2703,140 @@
   section_file_free(&file);
 }
 
+static void send_ruleset_modifier_types(struct conn_list *dest, bool is_gov)
+{
+  struct packet_ruleset_modifier_type packet;
+  int i, num_mods;
+  struct modifier_type *modifier_types;
+
+  if (is_gov) {
+    num_mods = game.num_gov_modifier_types;
+    modifier_types = gov_modifier_types;
+  } else {
+    num_mods = game.num_unit_modifier_types;
+    modifier_types = unit_modifier_types;
+  }
+
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier_type *u = &modifier_types[i];
+
+    packet.id = i;
+    packet.is_gov = is_gov;
+    packet.basetype = u->id;
+    sz_strlcpy(packet.name, u->name);
+    packet.tech_requirement = u->tech_requirement;
+    packet.must_use = u->must_use;
+    lsend_packet_ruleset_modifier_type(dest, &packet);
+  }
+}
+
+static void send_ruleset_unit_modifier_types(struct conn_list *dest)
+{
+  send_ruleset_modifier_types(dest, FALSE);
+}
+
+static void send_ruleset_gov_modifier_types(struct conn_list *dest)
+{
+  send_ruleset_modifier_types(dest, TRUE);
+}
+
+static void send_ruleset_modifiers(struct conn_list *dest, bool is_gov)
+{
+  struct packet_ruleset_modifier packet;
+  int i, num_mods;
+  struct modifier *modifiers;
+
+  if (is_gov) {
+    num_mods = game.num_gov_modifiers;
+    modifiers = gov_modifiers;
+  } else {
+    num_mods = game.num_unit_modifiers;
+    modifiers = unit_modifiers;
+  }
+
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier *u = &modifiers[i];
+
+    packet.id = i;
+    packet.is_gov = is_gov;
+    sz_strlcpy(packet.name, u->name);
+    packet.type = u->type;
+    packet.tech_requirement = u->tech_requirement;
+    packet.effect = u->effect;       /* pointer assignment */
+    lsend_packet_ruleset_modifier(dest, &packet);
+  }
+}
+
+static void send_ruleset_unit_modifiers(struct conn_list *dest)
+{
+  send_ruleset_modifiers(dest, FALSE);
+}
+
+static void send_ruleset_gov_modifiers(struct conn_list *dest)
+{
+  send_ruleset_modifiers(dest, TRUE);
+}
+
 /**************************************************************************
   Send the units ruleset information (all individual units) to the
   specified connections.
 **************************************************************************/
 static void send_ruleset_units(struct conn_list *dest)
 {
-  struct packet_ruleset_unit packet;
-
   unit_type_iterate(utype_id) {
-    struct unit_type *u = get_unit_type(utype_id);
+    send_single_unit(dest, utype_id);
+  } unit_type_iterate_end;
+}
 
-    packet.id = u-unit_types;
-    sz_strlcpy(packet.name, u->name_orig);
-    sz_strlcpy(packet.sound_move, u->sound_move);
-    sz_strlcpy(packet.sound_move_alt, u->sound_move_alt);
-    sz_strlcpy(packet.sound_fight, u->sound_fight);
-    sz_strlcpy(packet.sound_fight_alt, u->sound_fight_alt);
-    sz_strlcpy(packet.graphic_str, u->graphic_str);
-    sz_strlcpy(packet.graphic_alt, u->graphic_alt);
-    packet.move_type = u->move_type;
-    packet.build_cost = u->build_cost;
-    packet.pop_cost = u->pop_cost;
-    packet.attack_strength = u->attack_strength;
-    packet.defense_strength = u->defense_strength;
-    packet.move_rate = u->move_rate;
-    packet.tech_requirement = u->tech_requirement;
-    packet.impr_requirement = u->impr_requirement;
-    packet.vision_range = u->vision_range;
-    packet.transport_capacity = u->transport_capacity;
-    packet.hp = u->hp;
-    packet.firepower = u->firepower;
-    packet.obsoleted_by = u->obsoleted_by;
-    packet.fuel = u->fuel;
-    packet.flags = u->flags;
-    packet.roles = u->roles;
-    packet.happy_cost = u->happy_cost;
-    packet.shield_cost = u->shield_cost;
-    packet.food_cost = u->food_cost;
-    packet.gold_cost = u->gold_cost;
-    packet.paratroopers_range = u->paratroopers_range;
-    packet.paratroopers_mr_req = u->paratroopers_mr_req;
-    packet.paratroopers_mr_sub = u->paratroopers_mr_sub;
-    packet.effect = u->effect;       /* pointer assignment */
-    packet.helptext = u->helptext;   /* pointer assignment */
+/**************************************************************************
+  Sends a single unit type to the player, to allow individual unit types
+  to be resent later during the game if the details change
+**************************************************************************/
+void send_single_unit(struct conn_list *dest, Unit_Type_id utype_id)
+{
+  struct packet_ruleset_unit packet;
+  struct unit_type *u = get_unit_type(utype_id);
+  int i;
 
-    lsend_packet_ruleset_unit(dest, &packet);
-  } unit_type_iterate_end;
+  packet.id = u-unit_types;
+  sz_strlcpy(packet.name, u->name_orig);
+  sz_strlcpy(packet.sound_move, u->sound_move);
+  sz_strlcpy(packet.sound_move_alt, u->sound_move_alt);
+  sz_strlcpy(packet.sound_fight, u->sound_fight);
+  sz_strlcpy(packet.sound_fight_alt, u->sound_fight_alt);
+  sz_strlcpy(packet.graphic_str, u->graphic_str);
+  sz_strlcpy(packet.graphic_alt, u->graphic_alt);
+  packet.move_type = u->move_type;
+  packet.build_cost = u->build_cost;
+  packet.pop_cost = u->pop_cost;
+  packet.attack_strength = u->attack_strength;
+  packet.defense_strength = u->defense_strength;
+  packet.move_rate = u->move_rate;
+  packet.tech_requirement = u->tech_requirement;
+  packet.impr_requirement = u->impr_requirement;
+  packet.vision_range = u->vision_range;
+  packet.transport_capacity = u->transport_capacity;
+  packet.hp = u->hp;
+  packet.firepower = u->firepower;
+  packet.obsoleted_by = u->obsoleted_by;
+  packet.fuel = u->fuel;
+  packet.flags = u->flags;
+  packet.roles = u->roles;
+  packet.happy_cost = u->happy_cost;
+  packet.shield_cost = u->shield_cost;
+  packet.food_cost = u->food_cost;
+  packet.gold_cost = u->gold_cost;
+  packet.paratroopers_range = u->paratroopers_range;
+  packet.paratroopers_mr_req = u->paratroopers_mr_req;
+  packet.paratroopers_mr_sub = u->paratroopers_mr_sub;
+  packet.basetype = u->basetype;
+  for (i = 0; i < MAX_MODS; ++i) {
+    packet.modifiers[i] = u->modifiers[i];
+  }
+  packet.effect = u->effect;       /* pointer assignment */
+  packet.helptext = u->helptext;   /* pointer assignment */
+
+  lsend_packet_ruleset_unit(dest, &packet);
 }
 
 /**************************************************************************
